
/***************************************************************************

    This file is part of Zochova, Copyright 2009 Gabor Buella.

    Zochova is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zochova is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zochova.  If not, see <http://www.gnu.org/licenses/>.

***************************************************************************/

#pragma once

namespace zochova
{
	namespace log
	{
		class IWriter;
	}

	class ChessGame;

	namespace engine
	{
		class Thinker;
	}

	namespace communicate
	{
		class ICommunication;
	}

	class IOpeningBook;

	class Connections
	{
	public:

		static void run(log::IWriter* logw,
						log::IWriter* engingelogw,
						int argNThreads,
						IOpeningBook* argBook);

	private:
		Connections(log::IWriter* logw,
					log::IWriter* engingelogw,
					int argNThreads,
					IOpeningBook* argBook);

		Connections(Connections const&);

		~Connections();

		int nThreads;
		log::IWriter* engingeLog;
		IOpeningBook* book;
		communicate::ICommunication* comm;
		ChessGame* game;
		engine::Thinker* thinker;
		bool ponder;

		static Connections* instance;

		void new_game();
		void set_engine_white();
		void set_engine_black();
		void disconnect_engine();
		void connect_thinker_game();
		void setPonder();
		void unSetPonder();
	};
}
