
/***************************************************************************

    This file is part of Zochova, Copyright 2009 Gabor Buella.

    Zochova is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zochova is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zochova.  If not, see <http://www.gnu.org/licenses/>.

***************************************************************************/

#pragma once

#include "OpeningBook.h"

namespace zochova
{

	class EmptyOpeningBook : public IOpeningBook
	{
	public:

		EmptyOpeningBook() {};

		bool getMove(const State& argState, Move& m) {
			(void) argState;
			(void) m;
			return false;
		}

	}; // EmptyOpeningBook


	class RebelBook : public IOpeningBook
	{
	public:
		RebelBook(std::string argFileName,
				  std::string argRandom1FileName,
				  std::string argRandom2FileName,
				  std::string argTourFileName);
		bool getMove(const State& argState, Move& m);
	protected:
		std::string fileName;
		std::string random1FileName;
		std::string random2FileName;
		std::string tourFileName;

		int XD,XE,AZ,RND;
		long HK1,HK2;
		char _BORD[256];
		long *p_BORD;
		unsigned char _GB[100000]; 
		long RANDOM1[1120];
		long RANDOM2[1120];
		char EPD[200];
		char FROM[10],TO[10];

		
		void findInBook();

		void BOEK_BEGIN();
		void BOEKIN();
		void MAKE_HASHKEY();
	}; // RebelBook

	class pgsqlBook : public IOpeningBook
	{
	};

} // zochova
