
/***************************************************************************

    This file is part of Zochova, Copyright 2009 Gabor Buella.

    Zochova is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zochova is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zochova.  If not, see <http://www.gnu.org/licenses/>.

***************************************************************************/

#pragma once

#include "communicate.h"

#define MATE_SCORE (33216)

namespace zochova
{
	namespace communicate
	{

		class CommConsole : public ICommunication
		{
		public:
			void sendOutput(std::string str);
			CommConsole();
			CommConsole(std::string first_command);
			void moveAccepted();
			void moveIllegal();
			void run();
			void offerDraw() {};
			void acceptDraw() {};
			void resign();
			void newThinkingLine(const engine::search::Result& result) {};
		protected:
			bool isShowBoard;
			std::string firstcommand;
			void makeMove(const Move &m);
			bool newInput(std::string command);
		}; // CommConsole

		class CommXboard : public ICommunication
		{
		public:
			void sendOutput(std::string str);
			CommXboard();
			void newThinkingLine(const engine::search::Result& result);


			void offerDraw() {};
			void acceptDraw() {};
			void moveAccepted() {};
			void moveIllegal() {};
			void resign();


		protected:
			void makeMove(const Move &m);
			bool newInput(std::string command);
		}; // CommXboard

		class commUci : public ICommunication
		{
		public:
			void sendOutput(std::string str);
	//		comm_uci();
		protected:

		}; // CommUci

	} // communicate
} // zochova
