
/***************************************************************************

    This file is part of Zochova, Copyright 2009 Gabor Buella.

    Zochova is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zochova is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zochova.  If not, see <http://www.gnu.org/licenses/>.

***************************************************************************/

#include "low_level.h"

#ifdef ZOCHOVA_PLATFOTM_WINDOWS
#	include <windows.h>
#elif defined(ZOCHOVA_PLATFOTM_LINUX) || defined(ZOCHOVA_PLATFOTM_BSD)
#	include <unistd.h>
#endif

#include <time.h>


namespace zochova
{

	void delay(int csecs) {
		#ifdef ZOCHOVA_PLATFOTM_WINDOWS
			Sleep( csecs * 10 );
		#elif defined(ZOCHOVA_PLATFOTM_LINUX) || defined(ZOCHOVA_PLATFOTM_BSD)
			Sleep( (clock_t) csecs * CLOCKS_PER_SEC / 100 );
		#endif
	}

	class Timer::TimerData
	{
	public:
		clock_t t;
	};

	Timer::Timer() {
		startTime = new TimerData;
		startTime->t = clock();
	}

	Timer::~Timer() {
		delete startTime;
	}

	int Timer::query() {
		return ((clock() - startTime->t) *100) / CLOCKS_PER_SEC;
	}

}
