
/***************************************************************************

    This file is part of Zochova, Copyright 2009 Gabor Buella.

    Zochova is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zochova is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zochova.  If not, see <http://www.gnu.org/licenses/>.

***************************************************************************/

#pragma once

#define QSEARCH
		// do quiescence search

#define USE_TP
		// use transposition table

#ifdef USE_TP
// #define USE_QTP
		// use transposition table while quiescence search
#endif


#define KILLER_MOVE_COUNT 2
		// number of killer moves stored per ply
		// min 0  max 3


//#define USE_AWS
		// using aspiration windows

#define USE_PVS
		// using principal variation search

//#define USE_NULLMOVE_PRUNE


#ifdef USE_NULLMOVE_PRUNE

#define NULLMOVE_PRUNE_PLY 4

#define USE_VERIFYED_NULLMOVE
		// http://www.omiddavid.com/pubs/vrfd_null.pdf

#endif

//#define EVAL_STATIC
		// using static evaluation when defined
		// using dynamic when not defined

#define USE_MOVE_ORDERING_2

#ifdef USE_MOVE_ORDERING_2
//#define USE_LMR
	// use late move reduction
#endif

#define USE_COUNTER_MOVES
	// use counter move heuristics


#define USE_SEARCH_EXTENSIONS

#ifndef EVAL_STATIC
#define USE_SIMPLE_QSEARCH
#endif
